/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.migrationhub.model;

import java.io.Serializable;
import javax.annotation.Generated;

/**
 * 
 * @see <a href="http://docs.aws.amazon.com/goto/WebAPI/AWSMigrationHub-2017-05-31/DescribeMigrationTask"
 *      target="_top">AWS API Documentation</a>
 */
@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class DescribeMigrationTaskResult extends com.amazonaws.AmazonWebServiceResult<com.amazonaws.ResponseMetadata> implements Serializable, Cloneable {

    /**
     * <p>
     * Object encapsulating information about the migration task.
     * </p>
     */
    private MigrationTask migrationTask;

    /**
     * <p>
     * Object encapsulating information about the migration task.
     * </p>
     * 
     * @param migrationTask
     *        Object encapsulating information about the migration task.
     */

    public void setMigrationTask(MigrationTask migrationTask) {
        this.migrationTask = migrationTask;
    }

    /**
     * <p>
     * Object encapsulating information about the migration task.
     * </p>
     * 
     * @return Object encapsulating information about the migration task.
     */

    public MigrationTask getMigrationTask() {
        return this.migrationTask;
    }

    /**
     * <p>
     * Object encapsulating information about the migration task.
     * </p>
     * 
     * @param migrationTask
     *        Object encapsulating information about the migration task.
     * @return Returns a reference to this object so that method calls can be chained together.
     */

    public DescribeMigrationTaskResult withMigrationTask(MigrationTask migrationTask) {
        setMigrationTask(migrationTask);
        return this;
    }

    /**
     * Returns a string representation of this object; useful for testing and debugging.
     *
     * @return A string representation of this object.
     *
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        if (getMigrationTask() != null)
            sb.append("MigrationTask: ").append(getMigrationTask());
        sb.append("}");
        return sb.toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;

        if (obj instanceof DescribeMigrationTaskResult == false)
            return false;
        DescribeMigrationTaskResult other = (DescribeMigrationTaskResult) obj;
        if (other.getMigrationTask() == null ^ this.getMigrationTask() == null)
            return false;
        if (other.getMigrationTask() != null && other.getMigrationTask().equals(this.getMigrationTask()) == false)
            return false;
        return true;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int hashCode = 1;

        hashCode = prime * hashCode + ((getMigrationTask() == null) ? 0 : getMigrationTask().hashCode());
        return hashCode;
    }

    @Override
    public DescribeMigrationTaskResult clone() {
        try {
            return (DescribeMigrationTaskResult) super.clone();
        } catch (CloneNotSupportedException e) {
            throw new IllegalStateException("Got a CloneNotSupportedException from Object.clone() " + "even though we're Cloneable!", e);
        }
    }

}
